if not ShockAndAwe_Bars then return end

local L = LibStub("AceLocale-3.0"):GetLocale("ShockAndAwe_Bars")
local media = LibStub:GetLibrary("LibSharedMedia-3.0");
local _, _, _, clientVersion = GetBuildInfo()

ShockAndAwe_Bars.emptyOptions = { "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none" }
ShockAndAwe_Bars.singleOptions = { "st", "eb" ,"ue_uf" , "mw5_lb", "ss", "ll_sf5", "ue", "none" , "as_mw<2", "lb_as", "FS_UEF", "es", "sw", "none", "none", "ls_0"}
-- ShockAndAwe_Bars.singleOptions = { "st", "eb" ,"ue_uf" , "mw5_lb", "ss", "ll_sf5", "ue", "MW>3_LB_UF" , "as_mw<2", "lb_as", "FS_UEF", "es", "sw", "MW>1_LB", "none", "ls_0"}
ShockAndAwe_Bars.aoeOptions = { "st", "ue_uf", "eb", "mw5_cl", "ss", "ll_sf5", "ue", "fn", "as_mw<2", "cl_as", "fs", "es", "sw", "none", "none", "ls_0"}

ShockAndAwe_Bars.fonteffects = {
	["none"] = L["None"],
	["OUTLINE"] = L["OUTLINE"],
	["THICKOUTLINE"] = L["THICKOUTLINE"],
	["MONOCHROME"] = L["MONOCHROME"],
}

-------------------
-- Config details
-------------------
function ShockAndAwe_Bars:SetDefaultOptions()
	ShockAndAwe_Bars.defaults = {
		char = {
			disabled = false,
			specchangewarning = true,
			message = "Welcome Home!",
			movingframes = true,
			showicons = true,
			relativeTo = "UIParent",
			relativePoint = "CENTER",
			point = "CENTER",
			texture = "Blizzard",
			barfont = "Friz Quadrata TT",
			barfontsize = 12,
			barfonteffect = "none",
			msgfont = "Friz Quadrata TT",
			msgfontsize = 24,
			msgfonteffect = "none",
			border = "None",
			barborder = "Blizzard Tooltip",
			mw4sound = "Sound\\Spells\\ShootWandLaunchLightning.wav",
			mw4soundname = "SAA Maelstrom 1",
			mw5sound = "Sound\\Spells\\DynamiteExplode.wav",
			mw5soundname = "SAA Maelstrom 2",
			shieldsound = "Sound\\Doodad\\BellowIn.wav",
			shieldsoundname = "SAA Shield 1",
			weaponsound = "Sound\\Doodad\\BellowIn.wav",
			weaponsoundname = "SAA Shield 1",
			xOffset = 0,
			yOffset = -100,
			fWidth = 300,
			fHeight = 175,
			resetOn = true,
			scale = 1,
			bars = {},
			showBuffBars = true,
			flametongueshow = true,
			shearshow = false,
			windshearshow = true,
			sbtshow = false,
			wfoverlay = true,
			threatThreshold = 90,
			ssshow = true,
			firetotemshow = true,
			wfshow = true,
			fsdotshow = true,
			gcdshow = false,
			gcdfullwidth = false,
			llshow = true,
			fnshow = true,
			fsshow = true,
			unleashelementsshow = true,
			ElementalBlastShow = false,
			petshow = false,
			disablebars = false,
			maelstromLow = 40,
			maelstromHigh = 100,
			feralSpiritTalented = false,
			mw4soundplay = true,
			mw5soundplay = true,
			mw5repeat = 3,
			mwflash = true,
			shieldshow = true,
			msshow = true,
			msstacks = 0,
			arena = false,
			barstext = true,
			debug = false,
			msg = { r = 1, g = .5, b = 0, },
			msgtime = 2,
			newsitem = 0,
			castweaponrebuff = false,
			MSBToutputarea = "Notification",
			colours = {
				lightningshield = { r=0, g=0, b=1, a=.5 },
				noshield = { r=1, g=0, b=0, a=1 },
				
			},						
			binding = {
				show = true,
				relativeTo = "UIParent",
				relativePoint = "CENTER",
				point = "CENTER",
				fWidth = 200,
				fHeight = 50,
				xOffset = -200,
				yOffset = -100,
				alpha = 0.4,
				scale = 1,	
				mhspell = ShockAndAwe_Bars.constants["Windfury Weapon"],
				ohspell = ShockAndAwe_Bars.constants["Flametongue Weapon"],
				macroset = false,
			},
			warning = {
				show = true,
				duration = 3,
				shield = false,
				weapon = true,
				range = false,
				grounding = true,
				interrupt = true,
				purge = true,
				timeleft = 300, 
				colour = { r = 1, g = .5, b = 0, a = 0.5, },
				relativeTo = "UIParent",
				relativePoint = "TOP",
				point = "CENTER",
				fWidth = 400,
				fHeight = 75,
				xOffset = 0,
				yOffset = -250,
			}
		}
	}
	
	for key,value in pairs(ShockAndAwe_Bars.constants.Cooldown)
	do
		ShockAndAwe_Bars.defaults.char.bars[key] = { Enabled = false }
		ShockAndAwe_Bars.defaults.char.colours[key] = { r=0.6, g=0.7, b=0.7, a=.5 }
	end
	
	ShockAndAwe_Bars.defaults.char.bars["Energy"] = { Enabled = true }
	ShockAndAwe_Bars.defaults.char.bars["Stormstrike"].Enabled = true
	ShockAndAwe_Bars.defaults.char.bars["Flametongue"].Enabled = true
	ShockAndAwe_Bars.defaults.char.bars["Feral Spirit"].Enabled = true
	
	ShockAndAwe_Bars.defaults.char.colours["Energy"] = { r=1, g=.5, b=1, a=.9 }
	ShockAndAwe_Bars.defaults.char.colours["Lightning Shield"] = { r=0, g=0, b=1, a=.5 }
	ShockAndAwe_Bars.defaults.char.colours["No Shield"] = { r=1, g=0, b=0, a=1 }
	ShockAndAwe_Bars.defaults.char.colours["Flametongue"] = { r=1, g=.6, b=.2, a=.9 }
	ShockAndAwe_Bars.defaults.char.colours["Frostbrand"] = { r=.6, g=.6, b=1, a=.9 }
	ShockAndAwe_Bars.defaults.char.colours["Wind Shear"] = { r=.6, g=.6, b=.6, a=.9 }
	ShockAndAwe_Bars.defaults.char.colours["Maelstrom Weapon"] = { r=1, g=.5, b=1, a=.9 }	
	ShockAndAwe_Bars.defaults.char.colours["Boulderfist"] = { r=.9, g=.4, b=0, a=.9 }	
	ShockAndAwe_Bars.defaults.char.colours["Rockbiter"] = { r=.9, g=.4, b=0, a=.9 }	
	ShockAndAwe_Bars.defaults.char.colours["Crash Lightning"] = { r=1, g=1, b=.2, a=.5 } -- TODO Bertel option for this
	ShockAndAwe_Bars.defaults.char.colours["Lava Lash"] = { r=1, g=.1, b=.1, a=.9 }
	ShockAndAwe_Bars.defaults.char.colours["Feral Spirit"] = { r=0, g=.6, b=.95, a=.9 }
	ShockAndAwe_Bars.defaults.char.colours["Stormstrike"] = { r=1, g=1, b=.2, a=.9 }
	ShockAndAwe_Bars.defaults.char.colours["Doom Winds"] = { r=0.4, g=0.8, b=.95, a=.9 }
	
	return ShockAndAwe_Bars.defaults
end

function ShockAndAwe_Bars:ForceDefault()
	ShockAndAwe_Bars.db:ResetDB("char")
	ShockAndAwe_Bars:OnInitialize()
end

function ShockAndAwe_Bars:IsBarEnabled(barName)
	if ShockAndAwe_Bars.db.char.bars[barName] == nil then
		return false
	end
	return ShockAndAwe_Bars.db.char.bars[barName].Enabled
end

function ShockAndAwe_Bars:SetBarEnabled(barName, enabled)
	ShockAndAwe_Bars.db.char.bars[barName].Enabled = enabled
	ShockAndAwe_Bars:RedrawFrames()
end



function ShockAndAwe_Bars:VerifyOptions()
	
end

function ShockAndAwe_Bars:GetOptions()
	local options = { 
		name = "ShockAndAwe_Bars",
		handler = ShockAndAwe_Bars,
		type='group',
		childGroups ='tree',
		args = {
			frames = {
				name = L["Frame Options"],
				type = 'group',
				order = 1,
				args = {
					width = {
						type = 'range',
						name = L["Bar Width"],
						desc = L["help_width"],
						min = 100,
						max = 500,
						step = 10,
						get = "GetWidth",
						set = "SetWidth",
						order = 32,
					},
					scale = {
						type = 'range',
						name = L["Bar Scale"],
						desc = L["help_scale"],
						min = 0.10,
						max = 2.00,
						step = 0.05,
						get = "GetScale",
						set = "SetScale",
						order = 33,
					},
					xoffset = {
						type = 'range',
						name = L["Horizontal Offset"],
						desc = L["help_xoffset"],
						min = -1000,
						max = 1000,
						step = 10,
						get = function(desc) return ShockAndAwe_Bars.db.char.xOffset end,
						set = function(desc,val) ShockAndAwe_Bars.db.char.xOffset = val; ShockAndAwe_Bars:RedrawFrames() end,
						order = 33,
					},
					yoffset = {
						type = 'range',
						name = L["Vertical Offset"],
						desc = L["help_yoffset"],
						min = -1000,
						max = 1000,
						step = 10,
						get = function(desc) return ShockAndAwe_Bars.db.char.yOffset end,
						set = function(desc,val) ShockAndAwe_Bars.db.char.yOffset = val; ShockAndAwe_Bars:RedrawFrames() end,
						order = 33,
					},
					resetbars = {
						type = 'execute',
						name = L["Reset Bars"],
						desc = L["help_reset"],
						func = "ResetBars",
						order = 34,
					},
					resetuptime = {
						type = 'execute',
						name = L["Reset Uptime"],
						desc = L["help_reset_uptime"],
						func = "ResetUptime",
						order = 35,
					},
					resetpriority = {
						type = 'execute',
						name = L["Reset Priority"],
						desc = L["help_reset_priority"],
						func = "ResetPriority",
						order = 36,
					},
				},
			},
			Energybar = {
				name = "Energy Bar",
				type = 'group',
				order = 2,
				args = {
					enable = {
						type = 'toggle',
						name = "Energy",
						desc = string.format("Toggle %s bar", ShockAndAwe_Bars.constants.PowerType),
						get = (function() return ShockAndAwe_Bars:IsBarEnabled("Energy") end),
						set = (function(info,val) ShockAndAwe_Bars:SetBarEnabled("Energy", val) end),
						order = 1
					},
					colour = {
						type = 'color',
						name = "Energy_colour",
						desc = string.format("Set %s bar colour", "Energy"),
						get = (function() return ShockAndAwe_Bars:GetBarColour("Energy") end),
						set = (function(info,r,b,g) ShockAndAwe_Bars:SetBarColour("Energy", r,b,g) end),
						hasAlpha = true,
						order = 2,
					},
					mslow = {
						type = 'range',
						name = L["Maelstrom Low"],
						desc = L["colMaelstromLow"],
						min = 0,
						max = 150,
						isPercent = false,
						get = (function() return ShockAndAwe_Bars.db.char.maelstromLow end),
						set = (function(info,val) ShockAndAwe_Bars.db.char.maelstromLow = val end),
						order = 14,
					},
					mshigh = {
						type = 'range',
						name = L["Maelstrom High"],
						desc = L["colMaelstromHigh"],
						min = 0,
						max = 150,
						isPercent = false,
						get = (function() return ShockAndAwe_Bars.db.char.maelstromHigh end),
						set = (function(info,val) ShockAndAwe_Bars.db.char.maelstromHigh = val end),
						order = 15,
					}
				}
			},
			bars = {
				name = L["Timer Bars"],
				type = 'group',
				order = 3,
				args = {
					disable = {
						type = 'toggle',
						name = L["Disable out of combat"],
						desc = L["help_disablebars"],
						get = "disablebarsQuery",
						set = "Activatedisablebars",
						order = 1,
						},
					icons = {
						type = 'toggle',
						name = L["Show bar icons"],
						desc = L["help_baricons"],
						get = "bariconsQuery",
						set = "ActivateBarIcons",
						order = 2,
						},
					buffs = {
						type = 'toggle',
						name = L["Show buff timers"],
						desc = L["help_bufftimers"],
						get = (function() return ShockAndAwe_Bars.db.char.showBuffBars end),
						set = (function(info,val) ShockAndAwe_Bars.db.char.showBuffBars = val end),
						order = 2,
						},
					break1 = {
						type = 'header',
						name = L["Bars Section"],
						dialogHidden = true,
						order = 10,
					}
				},
			},
			barcolours = {
				name = L["Bar Colours"],
				type = 'group',
				order = 4, 
				args = {
					break1 = {
						type = 'header',
						name = L["Shields"],
						dialogHidden = true,
						order = 1,
					},
					break4 = {
						type = 'header',
						name = L["Other Bars"],
						dialogHidden = true,
						order = 20,
					}					
				},
			},
			warning = {
				name = L["Warning Options"],
				type = 'group',
				order = 6, 
				args = {
					show = {
						type = 'toggle',
						name = L["Use Warning Frame"],
						desc = L["help_warningframe"],
						get = "WarningFrameQuery",
						set = "ActivateWarningFrame",
						order = 1,
					},
					shield = {
						type = 'toggle',
						name = L["Shield Warning"],
						desc = L["help_shieldwarning"],
						get = "shieldWarnQuery",
						set = "ActivateShieldWarn",
						order = 2,
					},
					weapons = {
						type = 'toggle',
						name = L["Weapon Inbue Warning"],
						desc = L["help_weaponwarning"],
						get = "weaponWarnQuery",
						set = "ActivateWeaponWarn",
						order = 3,
					},
					range = {
						type = 'toggle',
						name = L["Out of range"],
						desc = L["help_outofrange"],
						get = "rangeWarnQuery",
						set = "ActivateRangeWarn",
						order = 4,
					},
					interrupt = {
						type = 'toggle',
						name = L["Interrupt Warning"],
						desc = L["help_interruptwarning"],
						get = "interruptWarnQuery",
						set = "ActivateInterruptWarn",
						order = 6,
					},
					purge = {
						type = 'toggle',
						name = L["Purge Warning"],
						desc = L["help_purgewarning"],
						get = "purgeWarnQuery",
						set = "ActivatePurgeWarn",
						order = 7,
					},
					
					colour = {
						type = 'color',
						name = L["Warning Msg Colour"],
						desc = L["colWarningMessage"],
						get = "getWarningColour",
						set = "setWarningColour",
						hasAlpha = true,
						order = 10,
					},
					duration = {
						type = 'range',
						name = L["Warning Message Duration"],
						min = 1,
						max = 10,
						step = .2,
						get = "GetWarningDuration",
						set = "SetWarningDuration",
						order = 11,
					},
				},
			},
			media = {
				name = L["Media Options"],
				type = 'group',
				order = 7, 
				args = {
					texture = {
						type = 'select',
						name = L["Bar Texture"],
						get = "GetBarTexture",
						set = "SetBarTexture",
						values = ShockAndAwe_Bars.textures,
						order = 1,
					},
					border = {
						type = 'select',
						name = L["Border Texture"],
						get = "GetBorderTexture",
						set = "SetBorderTexture",
						values = ShockAndAwe_Bars.borders,
						order = 2,
					},
					barborder = {
						type = 'select',
						name = L["Bar Border Texture"],
						get = "GetBarBorderTexture",
						set = "SetBarBorderTexture",
						values = ShockAndAwe_Bars.borders,
						order = 3,
					},
					barfont = {
						type = 'select',
						name = L["Bar Font"],
						get = "GetBarFont",
						set = "SetBarFont",
						values = ShockAndAwe_Bars.fonts,
						order = 4,
					},
					barfonteffect = {
						name = L["Bar Font Effect"],
						type = "select",
						get = "GetBarFontEffect",
						set = "SetBarFontEffect",
						values = ShockAndAwe_Bars.fonteffects,
						order = 5,
					},
					barfontsize = {
						type = 'range',
						name = L["Bar Font Size"],
						min = 6,
						max = 32,
						step = 1,
						get = "GetBarFontSize",
						set = "SetBarFontSize",
						order = 6,
					},
					msgfont = {
						type = 'select',
						name = L["Message Font"],
						get = "GetMsgFont",
						set = "SetMsgFont",
						values = ShockAndAwe_Bars.fonts,
						order = 7,
					},
					msgfonteffect = {
						name = L["Message Font Effect"],
						type = "select",
						get = "GetMsgFontEffect",
						set = "SetMsgFontEffect",
						values = ShockAndAwe_Bars.fonteffects,
						order = 8,
					},
					msgfontsize = {
						type = 'range',
						name = L["Message Font Size"],
						min = 6,
						max = 32,
						step = 1,
						get = "GetMsgFontSize",
						set = "SetMsgFontSize",
						order = 9,
					}					
				},
			},
			specchangewarning = {
				type = 'toggle',
				name = L["Warn on Spec Change"],
				desc = L["help_specchangewarning"],
				get = "specchangewarningQuery",
				set = "Activatespecchangewarning",
				order = 19,
			},			
			debug = {
				type = 'toggle',
				name = L["Debug mode"],
				desc = L["help_debug"],
				get = "debugQuery",
				set = "ActivateDebug",
				order = 20,
			},
			moveframes = {
				type = 'toggle',
				name = L["Move Frames"],
				desc = L["help_display"],
				get = "MovingFramesQuery",
				set = "ShowHideBars",
				order = 21,
			},
			testbar = {
				type = 'execute',
				name = L["Display Test Bar"],
				desc = L["help_testbar"],
				func = "WFProcBar",
				order = 22,
			},
			export = {
				type = 'execute',
				name = L["Export to Sim"],
				desc = L["help_export"],
				func = "ExportToSim",
				order = 23,
			},
			config = {
				type = 'execute',
				name = L["Configure Options"],
				desc = L["help_config"],
				func = "OpenConfig",
				order = 24,
			},
			news = {
				type = 'execute',
				name = L["Display News"],
				desc = L["help_news"],
				func = function() ShockAndAwe_Bars:News(true); end,
				order = 25,
			},
			enable = {
				type = 'execute',
				name = L["Enable/Disable"],
				desc = L["help_disable"],
				func = "EnableDisable",
				order = 26,
			},
			disable = {
				type = 'execute',
				name = L["Enable/Disable"],
				desc = L["help_disable"],
				func = "EnableDisable",
				guiHidden = true,
				order = 27,
			},
			reset = {
				type = 'execute',
				name = "Reset to Default",
				desc = "Reset all settings to default",
				func = "ForceDefault",
				order = 28,
			},
			help = {
				type = 'description',
				name = L["help"],
				guiHidden = true,
				order = 30,
			}			
		}
	}
	
	local barDisplayOrder = 11
	local key,value
	for key,value in pairs(ShockAndAwe_Bars.constants.Cooldown)
	do
		local optionKey= tostring(ShockAndAwe_Bars.constants.SpellID[key])
		if value > 0 then
			if not (key == "Energy") then
				options.args.bars.args[optionKey] = {
					type = 'toggle',
					name = key,
					desc = string.format("Toggle %s bar", key),
					get = (function() return ShockAndAwe_Bars:IsBarEnabled(key) end),
					set = (function(info,val) ShockAndAwe_Bars:SetBarEnabled(key, val) end),
					order = barDisplayOrder
				}

				options.args.barcolours.args[optionKey] = {
					type = 'color',
								name = key,
								desc = string.format("Set %s bar colour", key),
								get = (function() return ShockAndAwe_Bars:GetBarColour(key) end),
								set = (function(info,r,b,g) ShockAndAwe_Bars:SetBarColour(key, r,b,g) end),
								hasAlpha = true,
								order = barDisplayOrder,
				}
				barDisplayOrder = barDisplayOrder + 1
			end
		end
	end
	
	return options
end



function ShockAndAwe_Bars:ActivateArena()
	ShockAndAwe_Bars.db.char.arena = not ShockAndAwe_Bars.db.char.arena
	ShockAndAwe_Bars:SetTalentEffects()
	ShockAndAwe_Bars:RedrawFrames()
	if (ShockAndAwe_Bars.db.char.arena) then
		ShockAndAwe_Bars:Print(L["config_Arena_on"])
	else
		ShockAndAwe_Bars:Print(L["config_Arena_off"])
	end
end

function ShockAndAwe_Bars:Activatedisablebars()
	ShockAndAwe_Bars.db.char.disablebars = not ShockAndAwe_Bars.db.char.disablebars
	if (ShockAndAwe_Bars.db.char.disablebars) then
		if not InCombatLockdown() then
			ShockAndAwe_Bars.BaseFrame:Hide()
		end
		ShockAndAwe_Bars:Print(L["config_disable_on"])
	else
		ShockAndAwe_Bars.BaseFrame:Show()
		ShockAndAwe_Bars:Print(L["config_disable_off"])
	end
end

function ShockAndAwe_Bars:ActivateBarIcons()
	ShockAndAwe_Bars.db.char.showicons = not ShockAndAwe_Bars.db.char.showicons
	if (ShockAndAwe_Bars.db.char.showicons) then
		ShockAndAwe_Bars:Print(L["config_baricons_on"])
	else
		ShockAndAwe_Bars:Print(L["config_baricons_off"])
	end
end

function ShockAndAwe_Bars:ActivateDebug()
	ShockAndAwe_Bars.db.char.debug = not ShockAndAwe_Bars.db.char.debug
	if (ShockAndAwe_Bars.db.char.debug) then
		ShockAndAwe_Bars:Print(L["config_debug_on"])
	else
		ShockAndAwe_Bars:Print(L["config_debug_off"])
	end
end

function ShockAndAwe_Bars:Activatespecchangewarning()
	ShockAndAwe_Bars.db.char.specchangewarning = not ShockAndAwe_Bars.db.char.specchangewarning
	if (ShockAndAwe_Bars.db.char.specchangewarning) then
		ShockAndAwe_Bars:Print(L["config_specchangewarning_on"])
	else
		ShockAndAwe_Bars:Print(L["config_specchangewarning_off"])
	end
end


function ShockAndAwe_Bars:ActivateTextOnBars()
	ShockAndAwe_Bars.db.char.barstext = not ShockAndAwe_Bars.db.char.barstext
	ShockAndAwe_Bars:UpdateShieldBar()
	if (ShockAndAwe_Bars.db.char.barstext) then
		ShockAndAwe_Bars:Print(L["config_Barstext_on"])
	else
		ShockAndAwe_Bars:Print(L["config_Barstext_off"])
	end
end


function ShockAndAwe_Bars:ShowPetFrame()
	ShockAndAwe_Bars.db.char.petframeshow = not ShockAndAwe_Bars.db.char.petframeshow
	if ShockAndAwe_Bars.db.char.petframeshow then
		ShockAndAwe_Bars:EnablePetFrame()
		ShockAndAwe_Bars:Print(L["Enabled display of Feral Spirit Pet frame"])
	else
		ShockAndAwe_Bars:Print(L["Disabled display of Feral Spirit Pet frame"])
	end
end

function ShockAndAwe_Bars:ShowHideBars()
	ShockAndAwe_Bars.db.char.movingframes = not ShockAndAwe_Bars.db.char.movingframes
	if ShockAndAwe_Bars.db.char.movingframes then
		ShockAndAwe_Bars.msgFrame:EnableMouse(1)
		ShockAndAwe_Bars.msgFrame:SetBackdropColor(0, 0, 0, 1)
		ShockAndAwe_Bars.msgFrame:Show()
		ShockAndAwe_Bars.BaseFrame:EnableMouse(1)
		ShockAndAwe_Bars.BaseFrame:SetBackdropColor(0, 0, 0, 1);
		ShockAndAwe_Bars.frames["Maelstrom Weapon"]:Show()
		ShockAndAwe_Bars.frames["Stormstrike"]:Show()
		
	else
		ShockAndAwe_Bars.msgFrame:EnableMouse(0)
		ShockAndAwe_Bars.msgFrame:SetBackdropColor(1, 1, 1, 0);
		-- ShockAndAwe_Bars.BaseFrame:Hide()
		ShockAndAwe_Bars.BaseFrame:SetBackdropColor(1, 1, 1, 0);
		ShockAndAwe_Bars.frames["Maelstrom Weapon"]:Hide()
		ShockAndAwe_Bars.frames["Stormstrike"]:Hide()
		
	end
	
	ToggleFrameMovers( ShockAndAwe_Bars.msgFrame, ShockAndAwe_Bars.db.char.movingframes)
	ToggleFrameMovers( ShockAndAwe_Bars.BaseFrame, ShockAndAwe_Bars.db.char.movingframes)
	
end

function ToggleFrameMovers( frame, enabled )

	if enabled == true then
		frame:RegisterForDrag("LeftButton")
	else
		frame:RegisterForDrag()
	end
	
end

function ShockAndAwe_Bars:FinishedMoving(var, frame)
	local point, relativeTo, relativePoint, xOffset, yOffset = frame:GetPoint();
	var.point = point
	var.relativeTo = relativeTo
	var.relativePoint = relativePoint
	var.xOffset = xOffset
	var.yOffset = yOffset
end

function ShockAndAwe_Bars:MovingFramesQuery()
	return ShockAndAwe_Bars.db.char.movingframes
end

function ShockAndAwe_Bars:PetFrameQuery()
	return ShockAndAwe_Bars.db.char.petframeshow
end


function ShockAndAwe_Bars:disablebarsQuery()
	return ShockAndAwe_Bars.db.char.disablebars
end

function ShockAndAwe_Bars:bariconsQuery()
	return ShockAndAwe_Bars.db.char.showicons
end

function ShockAndAwe_Bars:textOnBarsQuery()
    return ShockAndAwe_Bars.db.char.barstext
end

function ShockAndAwe_Bars:debugQuery()
	return ShockAndAwe_Bars.db.char.debug
end

function ShockAndAwe_Bars:specchangewarningQuery()
	return ShockAndAwe_Bars.db.char.specchangewarning
end

function ShockAndAwe_Bars:GetBarTexture()
    return ShockAndAwe_Bars.db.char.texture
end

function ShockAndAwe_Bars:GetBorderTexture()
    return ShockAndAwe_Bars.db.char.border
end

function ShockAndAwe_Bars:GetBarBorderTexture()
    return ShockAndAwe_Bars.db.char.barborder
end

function ShockAndAwe_Bars:GetBarFont()
    return ShockAndAwe_Bars.db.char.barfont
end

function ShockAndAwe_Bars:GetBarFontSize()
    return ShockAndAwe_Bars.db.char.barfontsize
end

function ShockAndAwe_Bars:GetBarFontEffect()
    return ShockAndAwe_Bars.db.char.barfonteffect
end

function ShockAndAwe_Bars:GetMsgFont()
    return ShockAndAwe_Bars.db.char.msgfont
end

function ShockAndAwe_Bars:GetMsgFontSize()
    return ShockAndAwe_Bars.db.char.msgfontsize
end

function ShockAndAwe_Bars:GetMsgFontEffect()
    return ShockAndAwe_Bars.db.char.msgfonteffect
end

function ShockAndAwe_Bars:GetWidth()
    return ShockAndAwe_Bars.db.char.fWidth
end

function ShockAndAwe_Bars:GetScale()
    return ShockAndAwe_Bars.db.char.scale
end


function ShockAndAwe_Bars:GetRebuffTime()
    return ShockAndAwe_Bars.db.char.warning.timeleft
end

function ShockAndAwe_Bars:SetBarFont(info, newValue)
	ShockAndAwe_Bars.db.char.barfont = newValue
	ShockAndAwe_Bars:RedrawFrames()
end

function ShockAndAwe_Bars:SetBarFontSize(info, newValue)
	ShockAndAwe_Bars.db.char.barfontsize = newValue
	ShockAndAwe_Bars:RedrawFrames()
end

function ShockAndAwe_Bars:SetBarFontEffect(info, newValue)
	ShockAndAwe_Bars.db.char.barfonteffect = newValue
	ShockAndAwe_Bars:RedrawFrames()
end

function ShockAndAwe_Bars:SetMsgFont(info, newValue)
	ShockAndAwe_Bars.db.char.msgfont = newValue
	ShockAndAwe_Bars:CreateMsgFrame()
end

function ShockAndAwe_Bars:SetMsgFontSize(info, newValue)
	ShockAndAwe_Bars.db.char.msgfontsize = newValue
	ShockAndAwe_Bars:CreateMsgFrame()
end

function ShockAndAwe_Bars:SetMsgFontEffect(info, newValue)
	ShockAndAwe_Bars.db.char.msgfonteffect = newValue
	ShockAndAwe_Bars:CreateMsgFrame()
end

function ShockAndAwe_Bars:SetBarTexture(info, newValue)
	ShockAndAwe_Bars.db.char.texture = newValue
	ShockAndAwe_Bars:RedrawFrames()
	
end

function ShockAndAwe_Bars:SetBorderTexture(info, newValue)
	ShockAndAwe_Bars.db.char.border = newValue
	local newTexture = media:Fetch("border", ShockAndAwe_Bars.db.char.border)
	if newTexture then
		ShockAndAwe_Bars.frameBackdrop.edgeFile = newTexture
		ShockAndAwe_Bars:RedrawFrames()
	else
		if ShockAndAwe_Bars.db.char.debug then
			ShockAndAwe_Bars:Print("border texture not found. Trying to set "..ShockAndAwe_Bars.db.char.border)
		end
	end
end

function ShockAndAwe_Bars:SetBarBorderTexture(info, newValue)
	ShockAndAwe_Bars.db.char.barborder = newValue
	local newTexture = media:Fetch("border", ShockAndAwe_Bars.db.char.barborder)
	if newTexture then
		ShockAndAwe_Bars.barBackdrop.edgeFile = newTexture
		for key,value in pairs(ShockAndAwe_Bars.frames)
		do 
			ShockAndAwe_Bars.frames[key]:SetBackdrop(ShockAndAwe_Bars.barBackdrop)			
		end
		ShockAndAwe_Bars:RedrawFrames()
	else
		if ShockAndAwe_Bars.db.char.debug then
			ShockAndAwe_Bars:Print("bar border texture not found. Trying to set "..ShockAndAwe_Bars.db.char.barborder)
		end
	end
end

function ShockAndAwe_Bars:SetRebuffTime(info, newValue)
	ShockAndAwe_Bars.db.char.warning.timeleft = newValue
end

function ShockAndAwe_Bars:SetWidth(info,newValue)
	if InCombatLockdown() then
		ShockAndAwe_Bars:Print(L["Cannot change bar width in combat"])
		return
	end
	local wasMoving = ShockAndAwe_Bars.db.char.movingframes
	ShockAndAwe_Bars.db.char.fWidth = newValue
	ShockAndAwe_Bars:RedrawFrames()
	if wasMoving then
		ShockAndAwe_Bars:ShowHideBars()
	end
	ShockAndAwe_Bars:DebugPrint(L["Frame width set to : "]..ShockAndAwe_Bars.db.char.fWidth)	
end

function ShockAndAwe_Bars:SetScale(info,newValue)
	if InCombatLockdown() then
		ShockAndAwe_Bars:Print(L["Cannot change scale in combat"])
		return
	end
	local wasMoving = ShockAndAwe_Bars.db.char.movingframes
	ShockAndAwe_Bars.db.char.scale = newValue
	ShockAndAwe_Bars.BaseFrame:SetScale(ShockAndAwe_Bars.db.char.scale)
	ShockAndAwe_Bars:RedrawFrames()
	if wasMoving then
		ShockAndAwe_Bars:ShowHideBars()
	end
	ShockAndAwe_Bars:DebugPrint(L["Scale set to : "]..ShockAndAwe_Bars.db.char.scale)
end

-----------------------------------------
-- Colour choices getter/setters
-----------------------------------------

function ShockAndAwe_Bars:GetBarColour(barname)
	local colours = ShockAndAwe_Bars.db.char.colours[barname]
	return colours.r, colours.g, colours.b, colours.a
end

function ShockAndAwe_Bars:SetBarColour(barname,r,g,b,a)
	ShockAndAwe_Bars.db.char.colours[barname].r = r
	ShockAndAwe_Bars.db.char.colours[barname].g = g
	ShockAndAwe_Bars.db.char.colours[barname].b = b
	ShockAndAwe_Bars.db.char.colours[barname].a = a
	ShockAndAwe_Bars:RedrawFrames()
end


-----------------------------------------
-- Priority Choices
-----------------------------------------


---------------
-- Warnings
---------------

function ShockAndAwe_Bars:WarningFrameQuery()
	return ShockAndAwe_Bars.db.char.warning.show
end

function ShockAndAwe_Bars:ActivateWarningFrame()
	ShockAndAwe_Bars.db.char.warning.show = not ShockAndAwe_Bars.db.char.warning.show
	if (ShockAndAwe_Bars.db.char.warning.show) then
		ShockAndAwe_Bars:Print(L["config_warnframe_on"])
	else
		ShockAndAwe_Bars:Print(L["config_warnframe_off"])
	end
end

function ShockAndAwe_Bars:shieldWarnQuery()
	return ShockAndAwe_Bars.db.char.warning.shield
end

function ShockAndAwe_Bars:ActivateShieldWarn()
	ShockAndAwe_Bars.db.char.warning.shield = not ShockAndAwe_Bars.db.char.warning.shield
	if (ShockAndAwe_Bars.db.char.warning.shield) then
		ShockAndAwe_Bars:Print(L["config_shieldwarn_on"])
	else
		ShockAndAwe_Bars:Print(L["config_shieldwarn_off"])
	end
end

function ShockAndAwe_Bars:weaponWarnQuery()
	return ShockAndAwe_Bars.db.char.warning.weapon
end

function ShockAndAwe_Bars:ActivateWeaponWarn()
	ShockAndAwe_Bars.db.char.warning.weapon = not ShockAndAwe_Bars.db.char.warning.weapon
	if (ShockAndAwe_Bars.db.char.warning.weapon) then
		ShockAndAwe_Bars:Print(L["config_weaponwarn_on"])
	else
		ShockAndAwe_Bars:Print(L["config_weaponwarn_off"])
	end
end

function ShockAndAwe_Bars:rangeWarnQuery()
	return ShockAndAwe_Bars.db.char.warning.range
end

function ShockAndAwe_Bars:ActivateRangeWarn()
	ShockAndAwe_Bars.db.char.warning.range = not ShockAndAwe_Bars.db.char.warning.range
	if (ShockAndAwe_Bars.db.char.warning.range) then
		ShockAndAwe_Bars:Print(L["config_rangewarn_on"])
	else
		ShockAndAwe_Bars:Print(L["config_rangewarn_off"])
	end
end

function ShockAndAwe_Bars:groundingWarnQuery()
	return ShockAndAwe_Bars.db.char.warning.grounding
end

function ShockAndAwe_Bars:ActivateGroundingWarn()
	ShockAndAwe_Bars.db.char.warning.grounding = not ShockAndAwe_Bars.db.char.warning.grounding
	if (ShockAndAwe_Bars.db.char.warning.grounding) then
		ShockAndAwe_Bars:Print(L["config_groundingwarn_on"])
	else
		ShockAndAwe_Bars:Print(L["config_groundingwarn_off"])
	end
end

function ShockAndAwe_Bars:interruptWarnQuery()
	return ShockAndAwe_Bars.db.char.warning.interrupt
end

function ShockAndAwe_Bars:ActivateInterruptWarn()
	ShockAndAwe_Bars.db.char.warning.interrupt = not ShockAndAwe_Bars.db.char.warning.interrupt
	if (ShockAndAwe_Bars.db.char.warning.interrupt) then
		ShockAndAwe_Bars:Print(L["config_interruptwarn_on"])
	else
		ShockAndAwe_Bars:Print(L["config_interruptwarn_off"])
	end
end

function ShockAndAwe_Bars:purgeWarnQuery()
	return ShockAndAwe_Bars.db.char.warning.purge
end

function ShockAndAwe_Bars:ActivatePurgeWarn()
	ShockAndAwe_Bars.db.char.warning.purge = not ShockAndAwe_Bars.db.char.warning.purge
	if (ShockAndAwe_Bars.db.char.warning.purge) then
		ShockAndAwe_Bars:Print(L["config_purgewarn_on"])
	else
		ShockAndAwe_Bars:Print(L["config_purgewarn_off"])
	end
end

function ShockAndAwe_Bars:EnableDisable()
	if InCombatLockdown() then
		ShockAndAwe_Bars:Print(L["Cannot enable/disable addon in combat"])
		return
	end
	ShockAndAwe_Bars.db.char.disabled = not ShockAndAwe_Bars.db.char.disabled
	if (ShockAndAwe_Bars.db.char.disabled) then
		ShockAndAwe_Bars:OnDisable()
		ShockAndAwe_Bars.BaseFrame:Hide()
		ShockAndAwe_Bars:Print(L["config_disabled_on"])
	else
		ShockAndAwe_Bars:OnEnable()
		ShockAndAwe_Bars:RedrawFrames()
		ShockAndAwe_Bars.db.char.movingframes = true -- forces false in ShowHideBars to re-enable frames
		ShockAndAwe_Bars:ShowHideBars()
		ShockAndAwe_Bars:Print(L["config_disabled_off"])
	end
end

function ShockAndAwe_Bars:ResetImmunity()
	ShockAndAwe_Bars.db.char.immuneTargets = {}
	ShockAndAwe_Bars:Print(L["config_resetImmunity"])
end

function ShockAndAwe_Bars:GetMainHandImbue(info)
	return ShockAndAwe_Bars.db.char.binding.mhspell 
end

function ShockAndAwe_Bars:SetMainHandImbue(info, value)
	ShockAndAwe_Bars.db.char.binding.mhspell = value
	ShockAndAwe_Bars:UpdateBindings()
end

function ShockAndAwe_Bars:GetOffHandImbue(info)
	return ShockAndAwe_Bars.db.char.binding.ohspell 
end

function ShockAndAwe_Bars:SetOffHandImbue(info, value)
	ShockAndAwe_Bars.db.char.binding.ohspell = value
	ShockAndAwe_Bars:UpdateBindings()
end

function ShockAndAwe_Bars:GetMSBTareas(info)
	return ShockAndAwe_Bars.db.char.MSBToutputarea
end

function ShockAndAwe_Bars:SetMSBTareas(info, value)
	ShockAndAwe_Bars.db.char.MSBToutputarea = value
end

function ShockAndAwe_Bars:getWarningColour(info)
	local colours = ShockAndAwe_Bars.db.char.warning.colour
	return colours.r, colours.g, colours.b, colours.a
end

function ShockAndAwe_Bars:setWarningColour(info,r,g,b,a)
	ShockAndAwe_Bars.db.char.warning.colour.r = r
	ShockAndAwe_Bars.db.char.warning.colour.g = g
	ShockAndAwe_Bars.db.char.warning.colour.b = b
	ShockAndAwe_Bars.db.char.warning.colour.a = a
end

function ShockAndAwe_Bars:GetWarningDuration(info)
	return ShockAndAwe_Bars.db.char.warning.duration 
end

function ShockAndAwe_Bars:SetWarningDuration(info, priorityValue)
	ShockAndAwe_Bars.db.char.warning.duration = priorityValue
end

function ShockAndAwe_Bars:OpenConfig()
	if InterfaceOptionsFrame_OpenToCategory then
		InterfaceOptionsFrame_OpenToCategory("ShockAndAwe_Bars");
	else
		InterfaceOptionsFrame_OpenToFrame("ShockAndAwe_Bars");
	end
end

function ShockAndAwe_Bars:GetMSBTAreaDefaults()
    local i = 0;
	ShockAndAwe_Bars.MSBT = {}
	ShockAndAwe_Bars.MSBT.areas = {}
    if MikSBT ~= nil and MikSBT.IterateScrollAreas ~= nil then
        for scrollAreaKey, scrollAreaName in MikSBT.IterateScrollAreas() do
            i = i + 1
            ShockAndAwe_Bars.MSBT.areas[i] = scrollAreaName
        end
    end
end
